﻿namespace TetGenNativeWrapper
{
    using System;
    using System.Text;

    //code by chatgpt...mostly...

    // Define a class that exposes the native DLL functions to other .NET assemblies
    // You can use the same name and signature as the native functions, or provide a more idiomatic .NET API
    public class NativeDllAdapter
    {
        // You can use the same name and signature as the native functions
        // Just call the wrapper methods internally
        public static IntPtr tetCalculate(String behaviour, double[] vertXYZ, double[] vertAttr, int[] vertMarker, int[] numPoly, int[] numVertices, int[] vertIndex, int[] numFHoles, double[] fHoleXYZ, int[] facetMarker, double[] HoleXYZ, double[] RegionXYZ, double[] RegionAttrib, double[] RegionVolConst, int[] binSizes, String fileName)
        {
            return NativeDllWrapper.tetCalculate(behaviour, vertXYZ, vertAttr, vertMarker, numPoly, numVertices, vertIndex, numFHoles, fHoleXYZ, facetMarker, HoleXYZ, RegionXYZ,RegionAttrib,RegionVolConst,binSizes, fileName);
        }
        /*
        // You can also provide a more idiomatic .NET API
        // For example, you can use string instead of StringBuilder, and handle the marshaling yourself
        public static string NativeFunction2(string s)
        {
            // Allocate a buffer for the output string
            int len = 256;
            var buffer = new StringBuilder(len);

            // Copy the input string to the buffer
            buffer.Append(s);

            // Call the native function with the buffer and the length
            NativeDllWrapper.NativeFunction2(buffer, ref len);

            // Return the buffer as a string
            return buffer.ToString();
        }

        // You can also expose the delegate as a static event
        // This allows other .NET assemblies to subscribe to the native callback
        public static event NativeDllWrapper.NativeFunction3Delegate NativeFunction3;

        // You can also provide a method to invoke the native function pointer
        // This is useful if the function pointer is obtained dynamically
        public static int InvokeNativeFunction3(int x, int y)
        {
            // Check if the function pointer is initialized
            if (NativeDllWrapper.NativeFunction3 != null)
            {
                // Invoke the function pointer and return the result
                return NativeDllWrapper.NativeFunction3(x, y);
            }
            else
            {
                // Throw an exception or return a default value
                throw new InvalidOperationException("NativeFunction3 is not initialized.");
            }
        }*/
    }

}