﻿namespace TetGenNativeWrapper
{
    using System;
    using System.Runtime.InteropServices;

    //code by chatgpt...mostly...

    // Define a class that wraps the native DLL functions
    public class NativeDllWrapper
    {
        // Specify the name and location of the native DLL
        //private const string DllName = "TetGen2vvvv.dll";

        // Declare the native functions as static extern methods with [DllImport] attribute
        // Use the appropriate calling convention, parameter types, and marshaling options
        [DllImport("TetGen2vvvv.dll")]
        public static extern IntPtr tetCalculate(String behaviour, double[] vertXYZ, double[] vertAttr, int[] vertMarker, int[] numPoly, int[] numVertices, int[] vertIndex, int[] numFHoles, double[] fHoleXYZ, int[] facetMarker, double[] HoleXYZ, double[] RegionXYZ, double[] RegionAttrib, double[] RegionVolConst, int[] binSizes, String fileName);
        /*
        [DllImport("TetGen2vvvv.dll")]
        public static extern void NativeFunction2(string s, ref int len);
        /*
        // You can also define delegates and use Marshal.GetDelegateForFunctionPointer to get function pointers
        // This is useful for callbacks or dynamically loaded functions
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate int NativeFunction3Delegate(int x, int y);

        public static NativeFunction3Delegate NativeFunction3;

        // You can also use SetDllImportResolver to customize the DLL loading logic
        // This is useful for resolving different versions or architectures of the DLL
        static NativeDllWrapper()
        {
            NativeLibrary.SetDllImportResolver(typeof(NativeDllWrapper).Assembly, (name, assembly, path) =>
            {
                // Implement your custom logic here
                // For example, you can use NativeLibrary.Load to load the DLL from a specific location
                // You can also use Marshal.GetDelegateForFunctionPointer to get the function pointer for NativeFunction3
                // Return the DLL handle or IntPtr.Zero if not resolved
                return IntPtr.Zero;
            });
        }*/
    }


}